
// PelikortitAppletOld.java (c) 2004-2006 Kari Laitinen

// Huom! Tm ohjelmaversio ei ehk knny. Tm on VANHA VERSIO!!!!!

// http://www.naturalprogramming.com

// 2004-08-24 Tiedosto luotu.
// 2005-02-01 Satunnaisesti.tee_sekoitettu_paritaulukko()-metodi listty. 
// 2006-01-14 Korttipakka on Kuningaspakka- ja Pokeripakka-luokkien
//            yhteinen kantaluokka.
//            Satunnaisesti-luokka pantu omaan tiedostoonsa.
// 2006-10-24 Muutettu Swing-apletiksi
// 2007-01-13 Viimeisin muutos.
 
//  Taman ohjelman applet antaa mahdollisuuden kayttajalleen
//  jakaa kortteja pakasta ja katsella niita naytolla.
//  Pakan voi myos sekoittaa haluttaessa.

//  Lokakuussa 2004 tahan ohjelmaan tehtiin muutos. Kortteja
//  voi kaanneella nyt hiiren avulla.

//  Ohjelmassa olevat luokat on tarkoitettu yleiskayttoisiksi
//  luokiksi. Korttipakka-luokka kayttaa Satunnaisesti-luokkaa
//  korttien sekoituksessa.

//  Satunnaisesti.java oltava samassa kansiossa tt ohjelmaa
//  knnettess.

import java.awt.* ;
import java.awt.event.* ;
import javax.swing.* ;

interface Korttivakiot
{
   public static final int  HERTTA  =  1 ;
   public static final int  RUUTU   =  2 ;
   public static final int  PATA    =  3 ;
   public static final int  RISTI   =  4 ;

   public static final int  KORTIN_LEVEYS_PIKSELEINA   =   75 ;
   public static final int  KORTIN_KORKEUS_PIKSELEINA  =  100 ;
}


class Kortti  implements Korttivakiot
{
   int kortin_arvo ;
   int kortin_maa ;

   //  oikeinpain  =  kortti piirretaan tietopuoli nakyviin
   //  nurinpain   =  kortti piirretaan selkapuoli nakyviin

   boolean  tama_kortti_on_oikeinpain  =  false ;

   Point  kortin_paikka_pikseleina  =  null ;
   
   public Kortti ( int annettu_kortin_arvo,
                   int annettu_kortin_maa )
   {
      kortin_arvo  = annettu_kortin_arvo ;
      kortin_maa   = annettu_kortin_maa ;
   }

   public int lue_arvo()
   {
      return kortin_arvo  ;
   }

   public int lue_maa()
   {
      return kortin_maa ;
   }

   public void  kaanna_kortti()
   {
      if ( tama_kortti_on_oikeinpain  ==  true )
      {
         tama_kortti_on_oikeinpain  =  false ;
      }
      else
      {
         tama_kortti_on_oikeinpain  =  true ;
      }
   }

   public void  kaanna_kortti_oikeinpain()
   {
      tama_kortti_on_oikeinpain  =  true ;
   }

   public void  kaanna_kortti_nurinpain()
   {
      tama_kortti_on_oikeinpain  =  false ;
   }

   public boolean  kortti_on_oikeinpain()
   {
      return  (  tama_kortti_on_oikeinpain  ==  true  ) ;
   }

   public boolean  kortti_on_nurinpain()
   {
      return  (  tama_kortti_on_oikeinpain  ==  false  ) ;
   }

   public void  aseta_paikka_pikseleina(
                       Point  annettu_kortin_paikka_pikseleina )
   {
      kortin_paikka_pikseleina  =  annettu_kortin_paikka_pikseleina ;
   }

   public String lue_maa_stringina()
   {
      String  palautettava_stringi  =  "" ;

      switch( kortin_maa )
      {
      case  HERTTA :
         palautettava_stringi  =  "Hertta" ;
         break ;
      case  RUUTU :
         palautettava_stringi  =  "Ruutu" ;
         break ;
      case  PATA :
         palautettava_stringi  =  "Pata" ;
         break ;
      case  RISTI :
         palautettava_stringi  =  "Risti" ;
         break ;
      default:
         palautettava_stringi  =  "Kumma juttu" ;
      }

      return  palautettava_stringi ;
   }

   //  Ao. vertailumetodeita ei ole paljon testattu.

   public boolean on_samaa_maata_kuin( Kortti toinen_kortti )
   {
      return ( kortin_maa  ==  toinen_kortti.kortin_maa ) ;
   }

   public boolean on_eri_maata_kuin( Kortti toinen_kortti )
   {
      return ( kortin_maa  !=  toinen_kortti.kortin_maa ) ;
   }

   public boolean on_pienempi_kuin( Kortti toinen_kortti )
   {
      return ( kortin_arvo  <  toinen_kortti.kortin_arvo ) ;
   }

   public boolean on_suurempi_kuin( Kortti toinen_kortti )
   {
      return ( kortin_arvo  >  toinen_kortti.kortin_arvo ) ;
   }

   public boolean on_yhtasuuri_kuin( Kortti toinen_kortti )
   {
      return ( kortin_arvo  ==  toinen_kortti.kortin_arvo ) ;
   }

   public boolean on_erisuuri_kuin( Kortti toinen_kortti )
   {
      return ( kortin_arvo  !=  toinen_kortti.kortin_arvo ) ;
   }

   public boolean piste_on_talla_kortilla( Point annettu_piste )
   {
      return ( kortin_paikka_pikseleina  !=  null  &&
         annettu_piste.x  >=  kortin_paikka_pikseleina.x  &&
         annettu_piste.x  <=  kortin_paikka_pikseleina.x  +  
                                   KORTIN_LEVEYS_PIKSELEINA  &&
         annettu_piste.y  >=  kortin_paikka_pikseleina.y  &&
         annettu_piste.y  <=  kortin_paikka_pikseleina.y  +  
                                   KORTIN_KORKEUS_PIKSELEINA ) ;
   }

   public void piirra( Graphics  graphics )
   {
      if ( tama_kortti_on_oikeinpain   ==  true  )
      {
         graphics.setColor( Color.yellow ) ;
      }
      else
      {
         graphics.setColor( Color.lightGray ) ;
      }

      graphics.fillRect( kortin_paikka_pikseleina.x,
                         kortin_paikka_pikseleina.y,
                         KORTIN_LEVEYS_PIKSELEINA,
                         KORTIN_KORKEUS_PIKSELEINA ) ;

      graphics.setColor( Color.black ) ;
      
      graphics.drawRect( kortin_paikka_pikseleina.x,
                         kortin_paikka_pikseleina.y,
                         KORTIN_LEVEYS_PIKSELEINA,
                         KORTIN_KORKEUS_PIKSELEINA ) ;

      if ( tama_kortti_on_oikeinpain  ==  true )
      {
         graphics.drawString( lue_maa_stringina(),
                              kortin_paikka_pikseleina.x  + 20,
                              kortin_paikka_pikseleina.y  + 
                               ( ( KORTIN_KORKEUS_PIKSELEINA * 2 ) / 3 ) ) ;

         String  kortin_arvo_stringi  =  ""  +  kortin_arvo ;

         if ( kortin_arvo  ==  1  ||  kortin_arvo  ==  14 )
         {
            kortin_arvo_stringi  =  "1 Ace" ;
         }
         else if ( kortin_arvo  ==  13 )
         {
            kortin_arvo_stringi  =  "13 King" ;
         }
         else if ( kortin_arvo  ==  12 )
         {
            kortin_arvo_stringi  =  "12 Queen" ;
         }
         else if ( kortin_arvo  ==  11 )
         {
            kortin_arvo_stringi  =  "11 Jack" ;
         }

         graphics.drawString( kortin_arvo_stringi,
                              kortin_paikka_pikseleina.x  + 20,
                              kortin_paikka_pikseleina.y  + 
                                ( KORTIN_KORKEUS_PIKSELEINA  / 3  ) ) ;
      }
   }
}


//  Korttipakka-luokassa ei ole yhtn korttia. Tm luokka on
//  tarkoitettu kantaluokaksi siit johdetuille luokille.


class Korttipakka  implements Korttivakiot 
{
   static int[]  maat  =  { HERTTA, RUUTU, PATA, RISTI } ;
   
   Kortti[]  pakan_kortit   =  new  Kortti[ 52 ] ;
   
   int    kortteja_pakassa  =  0 ;
   
   public Korttipakka  kopioi_pakka()
   {
      Korttipakka  uusi_pakka  =  new  Korttipakka() ;

      int kortin_indeksi  =  0 ;

      while ( kortin_indeksi  <  kortteja_pakassa )
      {
         uusi_pakka.pakan_kortit[ kortin_indeksi ]  =
                                       pakan_kortit[ kortin_indeksi ] ;
         kortin_indeksi  ++ ;
      }

      uusi_pakka.kortteja_pakassa  =  kortteja_pakassa ;

      return uusi_pakka ;
   }

   public void sekoita_pakka()
   {
      if ( kortteja_pakassa  >  0 )
      {
         Korttipakka  toinen_pakka  =  kopioi_pakka() ;
      
         int[] satunnaisindeksit  =  Satunnaisesti.tee_sekoitettu_taulukko(
                                                        kortteja_pakassa ) ;
      
         for ( int kortin_indeksi  =  0 ;
                   kortin_indeksi  <  kortteja_pakassa ;
                   kortin_indeksi  ++ )
         {
             pakan_kortit[ kortin_indeksi ]  = 
                     toinen_pakka.pakan_kortit[
                          satunnaisindeksit[ kortin_indeksi ] ] ;
         }
      }
   }
   
   public void lisaa_kortti( Kortti uusi_kortti )
   {
      if ( kortteja_pakassa  <  52 )
      {
         pakan_kortit[ kortteja_pakassa ]  =  uusi_kortti ;
         kortteja_pakassa  ++  ;
      }
   }

   public Kortti ota_kortti()
   {
      //  Metodi palauttaa null-arvon jos kortteja ei pakassa ole.
      //  Arvo null tarkoittaa Javassa sita etta olioviittaus
      //  ei viittaa (osoita) mihinkaan olioon.

      //  Jos kortteja on pakassa, palautetaan viittaus pakan
      //  alimpaan korttiin, ja poistetaan kyseinen kortti pakasta.
      //  Taman luokan toiminta on ihan ok vaikka kortteja
      //  jaetaankin pakan alta.

      Kortti  annettava_kortti  =  null ;

      if ( kortteja_pakassa  >  0 )
      {
         annettava_kortti  =  pakan_kortit[ kortteja_pakassa - 1 ] ;
      
         pakan_kortit[ kortteja_pakassa - 1 ]  =  null ;
      
         kortteja_pakassa  -- ;
      }
            
      return  annettava_kortti  ;  
   }   
}

//  Kuningaspakka on korttipakka jossa ss on pienin kortti
//  ja kuningas on suurin kortti. Tt taidetaan loppujen lopuksi
//  tarvita aika harvassa korttipeliss.

class Kuningaspakka  extends  Korttipakka
{
   public Kuningaspakka()  // Konstruktori eli muodostin.
   {
      for ( int maan_indeksi  =  0 ;
                maan_indeksi  <  4 ;
                maan_indeksi  ++ )
      {
         for ( int kortin_arvo  =  1 ;
                   kortin_arvo  <  14 ;
                   kortin_arvo  ++ )
         {
            lisaa_kortti( new  Kortti( kortin_arvo, maat[ maan_indeksi ] ) ) ;
         }
      }
   }
}

/*  Luokka Pokeripakka on kuten Kuningaspakka, mutta siina assan
    numeroarvo on 14. Tuo kortti piirtyy luokan Kortti metodilla
    piirra() aivan kuten arvon 1 sisaltava assa, mutta Kortti-
    luokan vertailumetodit ymmartavat assa suurimmaksi.
*/

class Pokeripakka  extends  Korttipakka
{
   public Pokeripakka()
   {
      for ( int maan_indeksi  =  0 ;
                maan_indeksi  <  4 ;
                maan_indeksi  ++ )
      {
         for ( int kortin_arvo  =  2 ;
                   kortin_arvo  <  15 ;
                   kortin_arvo  ++ )
         {
            lisaa_kortti( new  Kortti( kortin_arvo, maat[ maan_indeksi ] ) ) ;
         }
      }
   }
}

public class PelikortitApplet extends JApplet
                              implements ActionListener,
                                         MouseListener,
                                         Korttivakiot
{
   JButton  jaa_kortit_button     =  new  JButton( "Jaa kortit" ) ;
   JButton  sekoita_pakka_button  =  new  JButton( "Sekoita pakka" ) ;


   //  Pokeripakka-oliossa assa on suurin.

   Korttipakka  korttipakka  =  new  Pokeripakka() ;

   Kortti[]  rivi_kortteja  =  new  Kortti[ 5 ] ;

   Kortti  yksinainen_kortti ;

   Kortti  valittu_kortti ;

   
   public void init()
   {
      setLayout( new BorderLayout() ) ;

      JPanel alareunan_paneeli  =  new  JPanel() ;

      jaa_kortit_button.addActionListener( this ) ;
      sekoita_pakka_button.addActionListener( this ) ;

      alareunan_paneeli.add( jaa_kortit_button ) ;
      alareunan_paneeli.add( sekoita_pakka_button ) ;

      add( "South", alareunan_paneeli ) ;

      addMouseListener(this);
   }
   
   public void actionPerformed( ActionEvent event )
   {
      if ( event.getSource() instanceof JButton )
      {
         if ( event.getSource()  ==  jaa_kortit_button )
         {
            for ( int kortin_indeksi  =  0 ;
                      kortin_indeksi  <  rivi_kortteja.length ;
                      kortin_indeksi  ++ )
            {
               rivi_kortteja[ kortin_indeksi ]  =  korttipakka.ota_kortti() ;

               Point  kortin_paikka  =  new  Point(
                  40  +  ( KORTIN_LEVEYS_PIKSELEINA + 20 ) * kortin_indeksi,
                  50 ) ;

               rivi_kortteja[ kortin_indeksi ].
                              aseta_paikka_pikseleina( kortin_paikka ) ;
            }

            yksinainen_kortti  =  korttipakka.ota_kortti() ;
            yksinainen_kortti.aseta_paikka_pikseleina(
                                          new  Point( 200, 200 ) ) ;
         }
         else if ( event.getSource()  ==  sekoita_pakka_button )
         {
            korttipakka.sekoita_pakka() ;
         }

         repaint() ;
      }
   }

   public void mouseClicked( MouseEvent event )
   {
      Point  klikkauspaikka  =  new Point( event.getX(), event.getY() );

      if ( rivi_kortteja[ 0 ]  !=  null )
      {
         for ( int kortin_indeksi  =  0 ;
                   kortin_indeksi  <  rivi_kortteja.length ;
                   kortin_indeksi  ++ )
         {
            if ( rivi_kortteja[ kortin_indeksi ].
                         piste_on_talla_kortilla( klikkauspaikka ) )
            {
               rivi_kortteja[ kortin_indeksi ].kaanna_kortti() ;

               //  valittu_kortti asetetaan viittaamaan klikattuun
               //  korttiin rivi_kortteja -taulukossa, mutta 
               //  valitulla kortilla ei muuten tehda mitaan tassa
               //  ohjelmassa.

               valittu_kortti  =  rivi_kortteja[ kortin_indeksi ] ;
            }
         }

         if ( yksinainen_kortti.piste_on_talla_kortilla( klikkauspaikka ) )
         {
            yksinainen_kortti.kaanna_kortti() ;
         }

         repaint() ;
      }
   }

   public void mouseEntered( MouseEvent event ) {}
   public void mouseExited( MouseEvent event ) {}
   public void mousePressed( MouseEvent event ) {}
   public void mouseReleased( MouseEvent event ) {}

   public void paint( Graphics graphics )
   {
      super.paint( graphics ) ;

      //  Jos rivi_kortteja-taulukkoon on jo pantu kortit,
      //  piirretaan ne yksitellen.

      if ( rivi_kortteja[ 0 ]  !=  null )
      {
         for ( int kortin_indeksi  =  0 ;
                   kortin_indeksi  <  rivi_kortteja.length ;
                   kortin_indeksi  ++ )
         {
            rivi_kortteja[ kortin_indeksi ].piirra( graphics ) ;
         }

         yksinainen_kortti.piirra( graphics ) ;
      }
      else
      {
         graphics.drawString( "KORTTEJA EI OLE JAETTU", 100, 100 ) ;
      }


/*   Seuraavaa luuppia kytettiin korttipakan testaukseen.
     Ohjelma ei toimi kun tm luuppi on kytss.


      for ( int kortin_indeksi  =  0 ;
                kortin_indeksi  <  52 ;
                kortin_indeksi  ++ )
      {
         Kortti  kortti_pakasta  =  korttipakka.ota_kortti() ;



         System.out.printf( " %6s %2d", kortti_pakasta.lue_maa_stringina(),
                             kortti_pakasta.lue_arvo() ) ;

      }

*/

/*    Seuraavaa ohjelmanptk kytettiin tee_sekoitettu_paritaulukko()-
      metodin testauksessa.

      int[] testitaulukko  =  Satunnaisesti.tee_sekoitettu_paritaulukko( 20 ) ;

      for ( int luvun_indeksi  =  0 ;
                luvun_indeksi  <  20 ;
                luvun_indeksi  ++ )
      {
         System.out.print( "  "  +  testitaulukko[ luvun_indeksi ] ) ;
      }

      System.out.print(  "\n" ) ;
**/
   }
}





